import { jsx } from 'react/jsx-runtime';
import _classCallCheck from '@babel/runtime/helpers/esm/classCallCheck';
import _createClass from '@babel/runtime/helpers/esm/createClass';
import _inherits from '@babel/runtime/helpers/esm/inherits';
import _defineProperty$1 from '@babel/runtime/helpers/esm/defineProperty';
import { PureComponent } from 'react';
import _typeof from '@babel/runtime/helpers/esm/typeof';
import { colors, createTheme, gridSize } from '@uidu/theme';
import styled from 'styled-components';

function _defineProperty(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
}

function ownKeys(object, enumerableOnly) {
  var keys = Object.keys(object);

  if (Object.getOwnPropertySymbols) {
    var symbols = Object.getOwnPropertySymbols(object);
    if (enumerableOnly) symbols = symbols.filter(function (sym) {
      return Object.getOwnPropertyDescriptor(object, sym).enumerable;
    });
    keys.push.apply(keys, symbols);
  }

  return keys;
}

function _objectSpread2(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i] != null ? arguments[i] : {};

    if (i % 2) {
      ownKeys(Object(source), true).forEach(function (key) {
        _defineProperty(target, key, source[key]);
      });
    } else if (Object.getOwnPropertyDescriptors) {
      Object.defineProperties(target, Object.getOwnPropertyDescriptors(source));
    } else {
      ownKeys(Object(source)).forEach(function (key) {
        Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
      });
    }
  }

  return target;
}

function _getPrototypeOf(o) {
  _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {
    return o.__proto__ || Object.getPrototypeOf(o);
  };
  return _getPrototypeOf(o);
}

function _isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !Reflect.construct) return false;
  if (Reflect.construct.sham) return false;
  if (typeof Proxy === "function") return true;

  try {
    Date.prototype.toString.call(Reflect.construct(Date, [], function () {}));
    return true;
  } catch (e) {
    return false;
  }
}

function _assertThisInitialized(self) {
  if (self === void 0) {
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  }

  return self;
}

function _possibleConstructorReturn(self, call) {
  if (call && (typeof call === "object" || typeof call === "function")) {
    return call;
  }

  return _assertThisInitialized(self);
}

function _createSuper(Derived) {
  var hasNativeReflectConstruct = _isNativeReflectConstruct();
  return function _createSuperInternal() {
    var Super = _getPrototypeOf(Derived),
        result;

    if (hasNativeReflectConstruct) {
      var NewTarget = _getPrototypeOf(this).constructor;
      result = Reflect.construct(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }

    return _possibleConstructorReturn(this, result);
  };
}

/** Note:
 * Lozenge does not support dark mode at the moment.
 * Hence, color values are the same.
 */

var defaultBackgroundColor = {
  "default": {
    light: colors.N40,
    dark: colors.N40
  },
  inprogress: {
    light: colors.B50,
    dark: colors.B50
  },
  moved: {
    light: colors.Y75,
    dark: colors.Y75
  },
  "new": {
    light: colors.P50,
    dark: colors.P50
  },
  removed: {
    light: colors.R50,
    dark: colors.R50
  },
  success: {
    light: colors.G50,
    dark: colors.G50
  }
};
var defaultTextColor = {
  "default": {
    light: colors.N500,
    dark: colors.N500
  },
  inprogress: {
    light: colors.B500,
    dark: colors.B500
  },
  moved: {
    light: colors.N800,
    dark: colors.N800
  },
  "new": {
    light: colors.P500,
    dark: colors.P500
  },
  removed: {
    light: colors.R500,
    dark: colors.R500
  },
  success: {
    light: colors.G500,
    dark: colors.G500
  }
};
var boldBackgroundColor = {
  "default": {
    light: colors.N500,
    dark: colors.N500
  },
  inprogress: {
    light: colors.B400,
    dark: colors.B400
  },
  moved: {
    light: colors.Y500,
    dark: colors.Y500
  },
  "new": {
    light: colors.P400,
    dark: colors.P400
  },
  removed: {
    light: colors.R400,
    dark: colors.R400
  },
  success: {
    light: colors.G400,
    dark: colors.G400
  }
};
var boldTextColor = {
  "default": {
    light: colors.N0,
    dark: colors.N0
  },
  inprogress: {
    light: colors.N0,
    dark: colors.N0
  },
  moved: {
    light: colors.N800,
    dark: colors.N800
  },
  "new": {
    light: colors.N0,
    dark: colors.N0
  },
  removed: {
    light: colors.N0,
    dark: colors.N0
  },
  success: {
    light: colors.N0,
    dark: colors.N0
  }
};
var Theme = createTheme(function (_ref) {
  var appearance = _ref.appearance,
      isBold = _ref.isBold,
      maxWidth = _ref.maxWidth;
  return _objectSpread2(_objectSpread2({}, _typeof(appearance) === 'object' ? _objectSpread2({
    backgroundColor: (isBold ? boldBackgroundColor : defaultBackgroundColor)["default"].light,
    textColor: (isBold ? boldTextColor : defaultTextColor)["default"].light
  }, appearance) : {
    backgroundColor: (isBold ? boldBackgroundColor[appearance] : defaultBackgroundColor[appearance]).light,
    textColor: (isBold ? boldTextColor[appearance] : defaultTextColor[appearance]).light
  }), {}, {
    maxWidth: maxWidth
  });
});

var BORDER_RADIUS = "40px";
var Container = styled.span.withConfig({
  displayName: "Container",
  componentId: "sc-5z8x30-0"
})(["background-color:", ";color:", ";max-width:100%;vertical-align:baseline;line-height:20px;display:inline-block;padding:1px 8px;font-size:12px;font-weight:500;letter-spacing:0.05em;border-radius:", ";text-transform:uppercase;"], function (props) {
  return props.backgroundColor;
}, function (props) {
  return props.textColor;
}, BORDER_RADIUS);

var HORIZONTAL_SPACING = "".concat(gridSize() / 2, "px");
var Content = styled.span.withConfig({
  displayName: "Content",
  componentId: "kuvtw4-0"
})(["display:inline-block;vertical-align:top;overflow:hidden;text-overflow:ellipsis;white-space:nowrap;box-sizing:border-box;padding:0 ", ";max-width:", ";width:100%;"], HORIZONTAL_SPACING, function (props) {
  return typeof props.maxWidth === 'number' ? "".concat(props.maxWidth, "px") : props.maxWidth;
});

var Lozenge = /*#__PURE__*/function (_PureComponent) {
  _inherits(Lozenge, _PureComponent);

  var _super = _createSuper(Lozenge);

  function Lozenge() {
    _classCallCheck(this, Lozenge);

    return _super.apply(this, arguments);
  }

  _createClass(Lozenge, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          theme = _this$props.theme,
          _children = _this$props.children;
      return /*#__PURE__*/jsx(Theme.Provider, {
        value: theme,
        children: /*#__PURE__*/jsx(Theme.Consumer, _objectSpread2(_objectSpread2({}, this.props), {}, {
          children: function children(tokens) {
            return /*#__PURE__*/jsx(Container, _objectSpread2(_objectSpread2({}, tokens), {}, {
              children: /*#__PURE__*/jsx(Content, _objectSpread2(_objectSpread2({}, tokens), {}, {
                children: _children
              }))
            }));
          }
        }))
      });
    }
  }]);

  return Lozenge;
}(PureComponent);

_defineProperty$1(Lozenge, "defaultProps", {
  isBold: false,
  appearance: 'default',
  maxWidth: 200
});

export default Lozenge;
